//
// apitest.cc
//
// apitest: A program to test the Query classes as replacement for the current
//            parsing code
//

#ifdef HAVE_CONFIG_H
#include "htconfig.h"
#endif /* HAVE_CONFIG_H */

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>

extern "C"{
#include "libhtdig_api.h"
}

//*****************************************************************************
// int main()
//
int
main(int argc, char *argv[])
{

    htsearch_parameters_struct      params;
    htsearch_query_struct           the_query;
    htsearch_query_match_struct    result;

    int num_results = 0;
    

    if (argc < 3)
    {
        printf("Error not enough parameters\n");
        return(-1);
    }

    printf("Searching Test\n");
    printf("file:[%s] query:[%s]\n", argv[1] ,argv[2]);

    //sprintf(params.configFile, "/home/httpd/cgi-bin/nealr.db/archive/archive.conf");
    sprintf(params.configFile, "%s", argv[1]);
    params.debug = FALSE;


    sprintf(the_query.raw_query, "%s", argv[2]); // HTDIG_MAX_QUERY_L
    the_query.algorithms_flag = HTSEARCH_ALG_BOOLEAN;
    the_query.sortby_flag = HTSEARCH_SORT_REV_SCORE;
    the_query.format = HTSEARCH_FORMAT_LONG;

    htsearch_open(&params);

    num_results = htsearch_query(&the_query);

    printf("Num Results [%d]\n", num_results);

    for (int i = 0; i < num_results; i++)
    {
        printf("[MATCH %d]\n", i);
        htsearch_get_nth_match(i, &result);
        printf("%s\n", result.title );
        printf("%s\n", result.URL );
        printf("%s\n", result.excerpt );
        printf("SCORE: %d [%d%%]\n", result.score, result.score_percent );
        printf("SIZE: [%d]\n", result.size);
        printf("TIME: [%s] [%s]\n", asctime(&result.time_tm), ctime(&result.time) );
        printf("---------------------------------\n\n");

    }

}

         /*
        char title[HTDIG_DOCUMENT_TITLE_L];
        char URL[HTDIG_MAX_FILENAME_PATH_L];
        char *excerpt;
        int  score;
        int  match_percent;     //top result is 100%
        time_t doc_date;
        int  size;
        */


